package GestureRecognition;

import java.util.Vector;

/**
 * User: mad - mad_bn@yahoo.com
 * Date: May 5, 2010
 * Time: 5:45:17 PM
 * PicFloyd
 */
public class Classifier {
    private Vector<GestureModel> gestures;
    private double lastProb;

    public Classifier() {
        gestures = new Vector<GestureModel>();
    }

    public void addGestureModel(GestureModel gesture) {
        gestures.add(gesture);
    }

    public int classifyGesture(Gesture gesture) {

        double sum = 0;
        for (int i = 0; i < gestures.size(); i++) {
            double defProb = gestures.elementAt(i).getDefaultProbability();
            double matProb = gestures.elementAt(i).matches(gesture);
            double pro = defProb*matProb;
            sum = sum +(defProb*matProb);
        }

        int recognized = -1; // which gesture has been recognized
        double recogprob = Integer.MIN_VALUE; // probability of this gesture
        double probgesture = 0; // temporal value for bayes algorithm
        double probmodel = 0; // temporal value for bayes algorith
        for (int i = 0; i < gestures.size(); i++) {
            double tmpgesture = this.gestures.elementAt(i).matches(gesture);
            double tmpmodel = this.gestures.elementAt(i).getDefaultProbability();

            /*if (((tmpmodel * tmpgesture) / sum) > recogprob) {
                probgesture = tmpgesture;
                probmodel = tmpmodel;
                recogprob = ((tmpmodel * tmpgesture) / sum);
                recognized = i;
            }  */
            if (probgesture<tmpgesture){
                probgesture = tmpgesture;
                probmodel = tmpmodel;
                recognized = i;
            }
        }

        // a gesture could be recognized
        if (probmodel > 0 && probgesture > 0) {
            //System.out.println("DefaultProb: "+probmodel+" ProbGest: "+probgesture);
            //this.lastProb = recogprob;
            return recognized;
        } else {
            // no gesture could be recognized
            return -1;
        }
    }
}
